var nodemailer = require("nodemailer");
const connection = require("./database");

var common = {
  sendEmail: function (to_email, subject, message, callback) {
    console.log(to_email);
    var transporter = nodemailer.createTransport({
      service: "gmail",
      auth: {
        user: process.env.EMAIL_ID,
        pass: process.env.EMAIL_PASSWORD,
      },
    });

    var mailOptions = {
      from: process.env.EMAIL_ID,
      to: to_email,
      subject: subject,
      html: message,
    };

    transporter.sendMail(mailOptions, function (error, info) {
      if (error) {
        console.log(error);
        callback(false);
      } else {
        console.log("Email sent: " + info.response);
        callback(true);
      }
    });
  },

  random: function () {
    return Math.floor(1000 + Math.random() * 9000);
  },

  //-----------------------genreate token ------------------------
  generateToken() {
    var randtoken = require("rand-token").generator();
    var usersession = randtoken.generate(
      64,
      "0123456789abcdefghijklmnopqrstuvwxyz"
    );
    return usersession;
  },

  //==================== Generate Otp =============================
  generatecode() {
    var randomotp = Math.floor(1000 + Math.random() * 9000);
    return randomotp;
  },
  // ---------------------------------TOKEN-----------------------------------------

  checkUpdateToken: function (request, callback) {
    console.log("token==========", request);

    connection.query(
      "select * from tbl_user_device where user_id = ?",
      [request.user_id],
      function (error, result) {
        console.log(result);
        if (!error && result.length > 0) {
          connection.query(
            `update tbl_user_device set ? where user_id = ${request.user_id}`,
            [request],
            function (error, result) {
              if (!error) {
                callback(result);
              } else {
                console.log(error);
              }
            }
          );
        } else {
          //insert
          connection.query(
            "insert into tbl_user_device set ?",
            [request],
            function (error, result) {
              if (!error) {
                callback(result);
              } else {
                console.log(error);
              }
            }
          );
        }
      }
    );
  },
};
module.exports = common;
