require("dotenv").config();
var express = require("express");
var app = express();
var validator = require("Validator")
var connection = require("./config/database");

app.use(express.text());
app.use(express.urlencoded({ extended: false }));

app.use("/v1/api_document/", require("./modules/v1/api_document/index"))

var auth = require("./modules/v1/auth/router");
var user = require("./modules/v1/user/router");
// const app = require("./api_document");

app.engine('html', require('ejs').renderFile);
app.set('view engine', 'html')
app.use('/', require("./middleware/validator").extractHeaderLanguage);
app.use('/', require("./middleware/validator").validateApikey);
app.use('/', require("./middleware/validator").validateHeaderToken);

app.use('/api/v1/auth', auth);
app.use('/api/v1/user', user);

try {
  app.listen(process.env.PORT);
  console.log("connected on crud task on port : " + process.env.PORT);
} catch (error) {
  console.log("connected to the server failed");
}
