const connection = require("../../../config/database");
var asyncLoop = require("node-async-loop");
var GLOBAL = require("../../../config/constant");
var common = require("../../../config/common");
const { required } = require("../../../language/en");
const { request } = require("express");
var middleware = require("../../../middleware/validator");
const globals = require("../../../config/constant");

var user = {
  //==================== Total Count ================================
  // reconnection count pending
  totalcount: function (request, callback) {
    connection.query(
      `SELECT COUNT(id) from tbl_follow_up where is_deleted=0 AND user_id=${request.user_id}`,
      function (error, followups) {
        //  console.log(sql);
        if (!error) {
          connection.query(
            `SELECT COUNT(id) from tbl_contact where is_deleted=0 AND user_id=${request.user_id}`,
            function (error, contacts) {
              if (!error) {
                connection.query(
                  `SELECT COUNT(id) from tbl_scheduled_meeting where  is_deleted=0 AND user_id=${request.user_id}`,
                  function (error, mettings) {
                    callback(
                      "1",
                      {
                        keyword: "rest_keywords_success_message",
                        components: {},
                      },
                      {
                        followups: followups,
                        contacts: contacts,
                        meetings: mettings,
                      }
                    );
                  }
                );
              }
            }
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            err
          );
        }
      }
    );
  },

  //===================== Contact listing ===========================
  contacts: function (request, callback) {
    if (request.filter_id == 0) {
      connection.query(
        `SELECT c.id,c.firstname,c.lastname,profile_image,c.level,c.last_update,ct.name as contact_type FROM tbl_contact c JOIN tbl_contacts_type ct ON ct.id = c.type WHERE c.is_deleted = 0 AND user_id=${request.user_id}`,
        function (error, result) {
          if (!error) {
            connection.query(
              "SELECT * from tbl_contact where is_active=1 and is_deleted=0",
              function (error, result) {
                callback(
                  "1",
                  { keyword: "rest_keywords_success_message", content: {} },
                  result
                );
              }
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else {
      connection.query(
        `SELECT c.id,c.firstname,c.lastname,profile_image,c.level,c.last_update,c.notes,ct.name as contact_type FROM tbl_contact c JOIN tbl_contacts_type ct ON ct.id = c.type WHERE c.is_deleted = 0 AND type=${request.filter_id} AND user_id=${request.user_id}`,
        function (error, result) {
          if (!error) {
            connection.query(
              "SELECT * from tbl_contact where is_active=1 and is_deleted=0",
              function (error, result) {
                callback(
                  "1",
                  { keyword: "rest_keywords_success_message", content: {} },
                  result
                );
              }
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    }
  },

  //===================== Follow-ups listing ===========================
  followups: function (request, callback) {
    if (request.filter_id == 0) {
      connection.query(
        `SELECT fu.id,fu.create_at,fu.notes,cn.id,cn.firstname,cn.lastname,cn.type,cn.level,cn.profile_image,cnt.name AS contact_type from tbl_follow_up fu JOIN tbl_contact cn ON cn.id=fu.contact_id JOIN tbl_contacts_type cnt ON cnt.id=cn.type where cn.is_deleted=0 AND fu.user_id=${request.user_id}`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else {
      connection.query(
        `SELECT fu.id,fu.create_at,fu.notes,cn.id,cn.firstname,cn.lastname,cn.type,cn.level,cn.profile_image,cnt.name AS contact_type from tbl_follow_up fu JOIN tbl_contact cn ON cn.id=fu.contact_id JOIN tbl_contacts_type cnt ON cnt.id=cn.type where cn.is_deleted=0 AND cn.type=${request.filter_id} AND fu.user_id=${request.user_id}`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    }
  },

  //-------------------- Add all Notes ---------------------------------
  addNotes: function (request, callback) {
    var data = {
      notes: request.notes,
      file: request.file,
    };

    if (request.label_id == 0) {
      connection.query(
        `UPDATE tbl_follow_up SET ? WHERE user_id = ${request.user_id} AND contact_id = ${request.contact_id}`,
        [data],
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else if (request.label_id == 2) {
      connection.query(
        `UPDATE tbl_scheduled_meeting SET ? WHERE user_id = ${request.user_id} AND contact_id = ${request.contact_id}`,
        [data],
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else if (request.label_id == 3) {
      connection.query(`UPDATE tbl_reconnects SET ? WHERE user_id = ${request.user_id} AND contact_id = ${request.contact_id}`,
        [data],
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    }
  },

  //--------------------------------------------------------------------
  
  //==================== Add Followup Notes ==============================
  addFollowupNotes: function (request, callback) {
    //console.log(request.user_id);
    data = {
      notes: request.notes,
      file: request.file,
    };
    connection.query(
      "UPDATE tbl_scheduled_meeting SET ? WHERE user_id = ? AND contact_id = ?",
      [data, request.user_id, request.contact_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //===================== Delete Followup =============================
  deleteFollowup: function (request, callback) {
    // console.log(request);
    connection.query(
      "UPDATE tbl_follow_up SET is_deleted ='1' WHERE user_id = ? AND contact_id = ?",
      [request.user_id, request.contact_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //===================== Meeting listing ============================
  meetings: function (request, callback) {
    if (request.filter_id == 0) {
      connection.query(
        `SELECT sm.id,cn.id,cn.firstname,cn.lastname,cn.level,cn.type,cnt.name AS contact_type FROM tbl_scheduled_meeting sm JOIN tbl_contact cn ON cn.id=sm.contact_id JOIN tbl_contacts_type cnt ON cnt.id=cn.type WHERE cn.is_deleted=0 AND sm.user_id=${request.user_id}`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else {
      connection.query(
        `SELECT sm.id,cn.id,cn.firstname,cn.lastname,cn.level,cn.type,cnt.name AS contact_type FROM tbl_scheduled_meeting sm JOIN tbl_contact cn ON cn.id=sm.contact_id JOIN tbl_contacts_type cnt ON cnt.id=cn.type WHERE cn.is_deleted=0 AND sm.user_id=${request.user_id} AND cn.type=${request.filter_id}`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    }
  },

  //==================== Add Meeting Notes ==============================
  addMeetingNotes: function (request, callback) {
    const data = {
      notes: request.notes,
      file: "",
    };

    connection.query(
      "UPDATE tbl_scheduled_meeting SET ? WHERE user_id = ? AND contact_id = ?",
      [data, request.user_id, request.contact_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //===================== Delete Meeting =============================
  deleteMeeting: function (request, callback) {
    // console.log(request);
    connection.query(
      "UPDATE tbl_scheduled_meeting SET is_deleted ='1' WHERE user_id = ? AND contact_id = ?",
      [request.user_id, request.contact_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //=================== Reconnect listing ==========================
  reconnects: function () {
    connection.query(
      "SELECT sm.id FROM sm JOIN tbl_contact cn ON cn.id=sm.contact_id WHERE cn.is_active=1 and cn.is_deleted=0",
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },
  //==================== Add Reconnect Notes =========================
  addMeetingNotes: function (request, callback) {
    const data = {
      notes: request.notes,
      file: "",
    };

    connection.query(
      "UPDATE  SET ? WHERE user_id = ? AND contact_id = ?",
      [data, request.user_id, request.contact_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //===================== Delete Reconnect =============================
  deleteMeeting: function (request, callback) {
    // console.log(request);
    connection.query(
      "UPDATE  SET is_deleted ='1' WHERE user_id = ? AND contact_id = ?",
      [request.user_id, request.contact_id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //==================== Filter Data ===================================
  filerData: function (request, callback) {
    console.log(request);
    if (request.label == "1") {
      connection.query(
        `SELECT id,firstname,lastname,level,type,profile_image FROM tbl_contact WHERE is_deleted=0 AND type=${request.type} AND user_id=${request.user_id}`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else if (request.label == "2") {
      connection.query(
        `SELECT c.* FROM tbl_contact c JOIN tbl_follow_up fu ON fu.contact_id=c.id where c.type=${request.type} and fu.user_id=${request.user_id} and c.is_deleted=0`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else if (request.label == "3") {
      connection.query(
        `SELECT * FROM tbl_contact c JOIN tbl_scheduled_meeting sm ON sm.contact_id=c.id where c.type=${request.type} and sm.user_id=${request.user_id} and c.is_deleted=0`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else if (request.label == "4") {
      connection.query(
        `SELECT * FROM tbl_contact c JOIN tbl_scheduled_meeting sm ON sm.contact_id=c.id where c.type=${request.type} and c.is_deleted=0`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", components: {} },
              error
            );
          }
        }
      );
    } else {
    }
  },
  //=================== Add new contact type ===========================
  addNewType: function (request, callback) {
    var data = {
      name: request.name,
      color_code: request.color,
    };

    connection.query(
      `INSERT INTO tbl_contacts_type SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },
  //==================== Rename Contact type ===========================
  renameType: function (request, callback) {
    console.log(request);
    connection.query(
      "UPDATE tbl_contacts_type SET name = ? WHERE is_deleted = '0' AND id = ?",
      [request.name, request.id],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //=================== Delete Contact type ============================
  deleteType: function (request, callback) {
    connection.query(
      `UPDATE tbl_contacts_type SET is_deleted ='1' WHERE id =${request.id} `,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //==================== Filter Level Wise =============================
  filteLevel: function (request, callback) {
    //console.log(request);
    connection.query(
      `SELECT id,firstname,lastname,level,type,create_at,profile_image FROM tbl_contact WHERE is_deleted=0 and level='${request.level}' and user_id=${request.user_id}`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //================= Filter Contact ==================================
  filteContacts: function (request, callback) {
    connection.query(``, function (error, result) {
      if (!error) {
        callback(
          "1",
          { keyword: "rest_keywords_success_message", content: {} },
          result
        );
      } else {
        callback(
          "0",
          { keyword: "text_user_something_wrong", components: {} },
          error
        );
      }
    });
  },

  //================ Add Contact ======================================
  addContact: function (request, callback) {
    var data = {
      user_id: request.user_id,
      firstname: request.firstname,
      lastname: request.lastname,
      country_code: request.country_code,
      email: request.email,
      phone_number: request.phone_number,
      type: request.type,
    };
    connection.query(
      `INSERT INTO tbl_contact SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //=============== Get Contact Details ==============================
  viewContactDetails: function (request, callback) {
    connection.query(
      `SELECT * FROM tbl_contact WHERE is_deleted=0 and id='${request.contact_id}' and user_id=${request.user_id}`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //============== Update Contact Details ===========================
  updateContactDetails: function (request, callback) {},

  //============= Contacts Filtering ==================================
  contactsFiltering: function (request, callback) {
    if (request.filter_no == 1) {
      connection.query(
        `SELECT id,firstname,lastname,level,create_at FROM tbl_contact WHERE is_deleted=0 ORDER BY create_at DESC`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", content: {} },
              error
            );
          }
        }
      );
    } else if (request.filter_no == 2) {
      connection.query(
        `SELECT id,firstname,lastname,level,create_at FROM tbl_contact WHERE is_deleted=0 AND level=3`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", content: {} },
              error
            );
          }
        }
      );
    } else if (request.filter_no == 3) {
      connection.query(
        `SELECT id,firstname,lastname,level,create_at FROM tbl_contact WHERE is_deleted=0 AND level=1`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", content: {} },
              error
            );
          }
        }
      );
    } else if (request.filter_no == 4) {
      connection.query(
        `SELECT id,firstname,lastname,level,create_at FROM tbl_contact WHERE is_deleted=0 ORDER BY create_at DESC`,
        function (error, result) {
          if (!error) {
            callback(
              "1",
              { keyword: "rest_keywords_success_message", content: {} },
              result
            );
          } else {
            callback(
              "0",
              { keyword: "text_user_something_wrong", content: {} },
              error
            );
          }
        }
      );
    }
  },
  //============= Notification listing ==============================
  notificationListing: function (request, callback) {
    console.log(request.user_id);
    connection.query(
      `SELECT * FROM tbl_notification WHERE is_deleted=0 and receiver_id=?`,
      [request.user_id],
      function (error, result) {
        console.log(result);
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //============ User Listing ======================================
  userListing: function (request, callback) {
    connection.query(
      `SELECT id,name FROM tbl_user WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //============= languageListing ====================================
  languageListing: function (request, callback) {
    connection.query(
      `SELECT id,name FROM tbl_language WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //============ socialMediaListing =================================
  socialMediaListing: function (request, callback) {
    connection.query(
      `SELECT * FROM tbl_social_media WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== timeZoneListing =====================================
  timeZoneListing: function (request, callback) {
    connection.query(
      `SELECT * FROM tbl_timezone WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== Team Goal ==========================================
  teamGoal: function (request, callback) {
    connection.query(
      `SELECT tm.id,tm.admin_id,tm.team_id,tm.member_id,u.name FROM tbl_team_members tm JOIN tbl_user u ON u.id=member_id where u.is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== Team Listing ======================================
  teamListing: function (request, callback) {
    connection.query(
      `SELECT t.id AS team_id, t.name, t.profile_image,u.name as admin_name FROM tbl_team_members tm JOIN tbl_team t ON t.id = tm.team_id JOIN tbl_user u ON u.id=t.admin_id WHERE tm.member_id = ${request.user_id} AND tm.is_deleted = 0`,
      function (error, result) {
        if (!error && result.length > 0) {
          asyncLoop(
            result,
            function (item, next) {
              connection.query(
                `SELECT tm.id, tm.team_id, tm.member_id, u.name, u.profile_image FROM tbl_team_members tm JOIN tbl_user u ON u.id = tm.member_id WHERE tm.team_id = ? AND u.is_deleted = 0`,
                [item.team_id],
                function (error, data) {
                  if (!error && data.length > 0) {
                    item.Members = data;
                  }
                  next();
                }
              );
            },
            function (error) {
              if (!error) {
                callback(
                  "1",
                  { keyword: "rest_keywords_success", content: {} },
                  result
                );
              } else {
                callback(
                  "0",
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== Teammate ==========================================
  // teamMembers: function(request, callback) {
  // console.log("teamMembers", request);

  // asyncLoop(request,function(item, next) {
  //   connection.query(`SELECT tm.id, tm.team_id, tm.member_id, u.name, u.profile_image FROM tbl_team_members tm JOIN tbl_user u ON u.id = tm.member_id WHERE tm.team_id = ? AND u.is_deleted = 0`, [item.team_id], function (error, data) {
  //       console.log("data",data);
  //       if (!error && data.length > 0) {
  //         item.Members = data
  //         next();
  //       }
  //       })},() => {
  //         callback("1", { keyword: 'rest_keywords_success', content: {} }, data)
  //     });
  //  },
  //=========== Create New Team ===================================
  creatTeam: function (request, callback) {
    var data = {
      name: request.team_name,
      profile_image: request.team_profile,
      admin_id: request.user_id,
    };
    connection.query(
      `INSERT INTO tbl_team SET ?`,
      [data],
      function (error, result) {
        console.log(result.insertId);

        if (!error) {
          var team = {
            member_id: request.member_id,
            team_id: result.insertId,
          };

          connection.query(
            `INSERT INTO tbl_team_members SET ?`,
            [team],
            function (error, result) {
              if (!error) {
                callback(
                  "1",
                  { keyword: "rest_keywords_success_message", content: {} },
                  result
                );
              } else {
                callback(
                  "0",
                  { keyword: "text_user_something_wrong", content: {} },
                  error
                );
              }
            }
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //========== Join team ==========================================
  joinTeam: function (request, callback) {
    var data = {
      team_id: request.team_id,
      member_id: request.user_id,
    };

    connection.query(
      `INSERT INTO tbl_team_members SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== Leave Team ========================================
  leaveTeam: function (request, callback) {
    connection.query(
      `UPDATE tbl_team_members SET is_deleted = '1' WHERE member_id = ${request.user_id} AND team_id=${request.team_id}`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=========== log History =======================================
  logHistory: function (request, callback) {
    connection.query(
      `SELECT cn.id,cn.firstname,cn.lastname,cn.profile_image,cn.type FROM tbl_contact cn JOIN tbl_follow_up fu ON fu.contact_id=cn.id WHERE fu.user_id=7 AND cn.is_deleted=0 ORDER BY fu.create_at DESC`,
      function (error, followups) {
        if (!error && followups.length >= 0) {
          connection.query(
            `SELECT cn.id,cn.firstname,cn.lastname,cn.profile_image,cn.type FROM tbl_contact cn JOIN tbl_scheduled_meeting sm ON sm.contact_id=cn.id WHERE sm.user_id=7 AND cn.is_deleted=0 ORDER BY sm.created_at DESC`,
            function (error, meetings) {
              if (!error && meetings.length >= 0) {
                connection.query(
                  `SELECT cn.id,cn.firstname,cn.lastname,cn.profile_image,cn.type FROM tbl_contact cn WHERE cn.is_deleted=0 AND type ='client' ORDER BY cn.create_at DESC`,
                  function (error, client) {
                    if (!error && client.length >= 0) {
                      callback(
                        "1",
                        {
                          keyword: "rest_keywords_success_message",
                          content: {},
                        },
                        {
                          followups: followups,
                          meetings: meetings,
                          client: client,
                        }
                      );
                    } else {
                    }
                  }
                );
              } else {
              }
            }
          );
        }
      }
    );
  },
  //=========== All Blog Listing ==================================
  allBloglisting: function (request, callback) {
    connection.query(
      `SELECT id,image,title,description FROM tbl_blog WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //================ View Blog ====================================
  viewBlog: function (request, callback) {
    connection.query(
      `SELECT id,image,title,description FROM tbl_blog WHERE is_deleted=0 and id=${request.blog_id}`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=============== All Chatavisity ===============================
  allChatavirsity: function (request, callback) {
    connection.query(
      `SELECT id,image,title,description,price FROM tbl_chatavirsity WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //================ View Chatavisity =============================
  viewChatavirsity: function (request, callback) {
    connection.query(
      `SELECT id,image,title,description,price FROM tbl_chatavirsity WHERE is_deleted=0 and id=${request.chatavirsity_id}`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //================ All Faqs =====================================
  allFaqs: function (request, callback) {
    connection.query(
      `SELECT id,question,answer FROM tbl_faqs WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=============== All Ambassabor ================================
  allAmbassabor: function (request, callback) {
    connection.query(
      `SELECT id,name,description FROM tbl_ambassador WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=============== Apply Ambassabor ==============================
  applyAmbassabor: function (request, callback) {
    connection.query(
      `Insert into FROM tbl_ambassador set = ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=============== allSubcription ================================
  allSubcription: function (request, callback) {
    connection.query(
      `SELECT id,title,money,description FROM tbl_subscription WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //=============== Buy Subcription ===============================
  buySubcription: function (request, callback) {
    connection.query(
      `SELECT id,title,money,description FROM tbl_subscription WHERE is_deleted=0`,
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", content: {} },
            error
          );
        }
      }
    );
  },

  //============== Contact Us =====================================
  contactUs: function (request, callback) {
    var data = {
      user_id: request.user_id,
      full_name: request.fullname,
      phone_number: request.phone_number,
      message: request.description,
    };

    connection.query(
      `INSERT INTO tbl_contact_us SET ?`,
      [data],
      function (error, result) {
        if (!error) {
          callback(
            "1",
            { keyword: "rest_keywords_success_message", content: {} },
            result
          );
        } else {
          callback(
            "0",
            { keyword: "text_user_something_wrong", components: {} },
            error
          );
        }
      }
    );
  },

  //==============
};

module.exports = user;
